// Copyright 2016 Proyectos y Sistemas de Mantenimiento SL (eProsima).
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.

/*!
 * @file Benchmark_small.hpp
 * This header file contains the declaration of the described types in the IDL file.
 *
 * This file was generated by the tool fastddsgen.
 */

#ifndef FAST_DDS_GENERATED__BENCHMARK_SMALL_HPP
#define FAST_DDS_GENERATED__BENCHMARK_SMALL_HPP

#include  <array>
#include <cstdint>
#include <utility>

#if defined(_WIN32)
#if defined(EPROSIMA_USER_DLL_EXPORT)
#define eProsima_user_DllExport __declspec( dllexport )
#else
#define eProsima_user_DllExport
#endif  // EPROSIMA_USER_DLL_EXPORT
#else
#define eProsima_user_DllExport
#endif  // _WIN32

#if defined(_WIN32)
#if defined(EPROSIMA_USER_DLL_EXPORT)
#if defined(BENCHMARK_SMALL_SOURCE)
#define BENCHMARK_SMALL_DllAPI __declspec( dllexport )
#else
#define BENCHMARK_SMALL_DllAPI __declspec( dllimport )
#endif // BENCHMARK_SMALL_SOURCE
#else
#define BENCHMARK_SMALL_DllAPI
#endif  // EPROSIMA_USER_DLL_EXPORT
#else
#define BENCHMARK_SMALL_DllAPI
#endif // _WIN32

/*!
 * @brief This class represents the structure BenchMarkSmall defined by the user in the IDL file.
 * @ingroup Benchmark_small
 */
class BenchMarkSmall
{
public:

    /*!
     * @brief Default constructor.
     */
    eProsima_user_DllExport BenchMarkSmall()
    {
    }

    /*!
     * @brief Default destructor.
     */
    eProsima_user_DllExport ~BenchMarkSmall()
    {
    }

    /*!
     * @brief Copy constructor.
     * @param x Reference to the object BenchMarkSmall that will be copied.
     */
    eProsima_user_DllExport BenchMarkSmall(
            const BenchMarkSmall& x)
    {
        m_array = x.m_array;

        m_index = x.m_index;

    }

    /*!
     * @brief Move constructor.
     * @param x Reference to the object BenchMarkSmall that will be copied.
     */
    eProsima_user_DllExport BenchMarkSmall(
            BenchMarkSmall&& x) noexcept
    {
        m_array = std::move(x.m_array);
        m_index = x.m_index;
    }

    /*!
     * @brief Copy assignment.
     * @param x Reference to the object BenchMarkSmall that will be copied.
     */
    eProsima_user_DllExport BenchMarkSmall& operator =(
            const BenchMarkSmall& x)
    {

        m_array = x.m_array;

        m_index = x.m_index;

        return *this;
    }

    /*!
     * @brief Move assignment.
     * @param x Reference to the object BenchMarkSmall that will be copied.
     */
    eProsima_user_DllExport BenchMarkSmall& operator =(
            BenchMarkSmall&& x) noexcept
    {

        m_array = std::move(x.m_array);
        m_index = x.m_index;
        return *this;
    }

    /*!
     * @brief Comparison operator.
     * @param x BenchMarkSmall object to compare.
     */
    eProsima_user_DllExport bool operator ==(
            const BenchMarkSmall& x) const
    {
        return (m_array == x.m_array &&
               m_index == x.m_index);
    }

    /*!
     * @brief Comparison operator.
     * @param x BenchMarkSmall object to compare.
     */
    eProsima_user_DllExport bool operator !=(
            const BenchMarkSmall& x) const
    {
        return !(*this == x);
    }

    /*!
     * @brief This function copies the value in member array
     * @param _array New value to be copied in member array
     */
    eProsima_user_DllExport void array(
            const std::array<char, 16384>& _array)
    {
        m_array = _array;
    }

    /*!
     * @brief This function moves the value in member array
     * @param _array New value to be moved in member array
     */
    eProsima_user_DllExport void array(
            std::array<char, 16384>&& _array)
    {
        m_array = std::move(_array);
    }

    /*!
     * @brief This function returns a constant reference to member array
     * @return Constant reference to member array
     */
    eProsima_user_DllExport const std::array<char, 16384>& array() const
    {
        return m_array;
    }

    /*!
     * @brief This function returns a reference to member array
     * @return Reference to member array
     */
    eProsima_user_DllExport std::array<char, 16384>& array()
    {
        return m_array;
    }

    /*!
     * @brief This function sets a value in member index
     * @param _index New value for member index
     */
    eProsima_user_DllExport void index(
            uint32_t _index)
    {
        m_index = _index;
    }

    /*!
     * @brief This function returns the value of member index
     * @return Value of member index
     */
    eProsima_user_DllExport uint32_t index() const
    {
        return m_index;
    }

    /*!
     * @brief This function returns a reference to member index
     * @return Reference to member index
     */
    eProsima_user_DllExport uint32_t& index()
    {
        return m_index;
    }

private:

    std::array<char, 16384> m_array{0};
    uint32_t m_index{0};

};

#endif // _FAST_DDS_GENERATED_BENCHMARK_SMALL_HPP_


